> ## Documentation Index
> Fetch the complete documentation index at: https://docs.withflock.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List Customers



## OpenAPI

````yaml get /customers
openapi: 3.0.0
info:
  title: Flock API
  description: API Documentation for Flock
  version: '1.0'
  contact: {}
servers:
  - url: https://api-dev.withflock.com
security: []
tags: []
paths:
  /customers:
    get:
      tags:
        - Customer
      operationId: CustomerController_listCustomers
      parameters:
        - name: limit
          required: true
          in: query
          schema:
            type: number
        - name: offset
          required: true
          in: query
          schema:
            type: number
        - name: externalUserId
          required: true
          in: query
          schema:
            type: string
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedCustomerResponseDTO'
      security:
        - accessKey: []
components:
  schemas:
    PaginatedCustomerResponseDTO:
      type: object
      properties:
        total:
          type: number
        limit:
          type: number
        offset:
          type: number
        data:
          type: array
          items:
            $ref: '#/components/schemas/CustomerResponseDTO'
      required:
        - total
        - limit
        - offset
        - data
    CustomerResponseDTO:
      type: object
      properties:
        id:
          type: string
        externalUserId:
          type: string
        email:
          type: string
        name:
          type: string
        referredBy:
          description: The customer who referred this customer
          nullable: true
          allOf:
            - $ref: '#/components/schemas/ReferredByDTO'
        referredById:
          type: object
          nullable: true
        referredByReferralId:
          type: string
          nullable: true
        referredInCampaignId:
          type: string
          nullable: true
        visitedReferralsCount:
          type: number
        convertedReferralsCount:
          type: number
        referralCode:
          type: string
        createdAt:
          format: date-time
          type: string
        updatedAt:
          format: date-time
          type: string
        deletedAt:
          format: date-time
          type: string
          nullable: true
        organizationId:
          type: string
        applicationId:
          type: string
        customProperties:
          type: object
          nullable: true
          additionalProperties: false
        environment:
          type: string
          enum:
            - production
            - test
      required:
        - id
        - externalUserId
        - email
        - name
        - referredBy
        - referredById
        - referredByReferralId
        - referredInCampaignId
        - visitedReferralsCount
        - convertedReferralsCount
        - referralCode
        - createdAt
        - updatedAt
        - deletedAt
        - organizationId
        - applicationId
        - customProperties
        - environment
    ReferredByDTO:
      type: object
      properties:
        id:
          type: string
        externalUserId:
          type: string
        email:
          type: string
        name:
          type: string
      required:
        - id
        - externalUserId
        - email
        - name
  securitySchemes:
    accessKey:
      type: apiKey
      in: header
      name: Authorization

````